"""
This type stub file was generated by pyright.
"""

"""Utilities for producing help strings for use in Fire CLIs.

Can produce help strings suitable for display in Fire CLIs for any type of
Python object, module, class, or function.

There are two types of informative strings: Usage and Help screens.

Usage screens are shown when the user accesses a group or accesses a command
without calling it. A Usage screen shows information about how to use that group
or command. Usage screens are typically short and show the minimal information
necessary for the user to determine how to proceed.

Help screens are shown when the user requests help with the help flag (--help).
Help screens are shown in a less-style console view, and contain detailed help
information.
"""
LINE_LENGTH = ...
SECTION_INDENTATION = ...
SUBSECTION_INDENTATION = ...
def HelpText(component, trace=..., verbose=...): # -> str:
  """Gets the help string for the current component, suitable for a help screen.

  Args:
    component: The component to construct the help string for.
    trace: The Fire trace of the command so far. The command executed so far
      can be extracted from this trace.
    verbose: Whether to include private members in the help screen.

  Returns:
    The full help screen as a string.
  """
  ...

def UsageText(component, trace=..., verbose=...): # -> str:
  """Returns usage text for the given component.

  Args:
    component: The component to determine the usage text for.
    trace: The Fire trace object containing all metadata of current execution.
    verbose: Whether to display the usage text in verbose mode.

  Returns:
    String suitable for display in an error screen.
  """
  ...

class ActionGroup:
  """A group of actions of the same kind."""
  def __init__(self, name, plural) -> None:
    ...
  
  def Add(self, name, member=...): # -> None:
    ...
  
  def GetItems(self): # -> zip[tuple[Any, Any]]:
    ...
  


